module Lock
  class LockError < StandardError; end

  def Lock::lock( basefile = 'lock/lock', try = 10, timeout = 600 )
    locking = false
    lockfile = "#{basefile}.#{Process::pid}.#{Time.now.to_i}"
    1.upto( try ) do |time|
      begin
        File.rename( basefile, lockfile )
        locking = true
        break
      rescue #rename failed
        begin
          Dir.glob( "#{basefile}.*" ).each do |oldlock|
            if /^#{basefile}\.\d+\.(\d+)/ =~ oldlock and
                Time.now.to_i - $1.to_i > timeout then
              File.rename( oldlock, lockfile )
              locking = true
              break
            end
          end
        rescue
        end
      end
      sleep( 1 )
    end
    raise Lock::LockError, "LockError: #{lockfile} #{$!}" unless locking
    begin
      yield
    ensure
      File.rename( lockfile, basefile ) if locking
    end
  end
end
