require 'util'
require 'catalog'

def mkdat_udb(udb, user = nil)
  users = get_users(udb)
  topic = get_topic(udb)

  r = ''
  if File.exist?('chat.txt')
    File.open('chat.txt', 'r') do |i|
      i.flock(File::LOCK_SH)
      r = i.readlines
      i.flock(File::LOCK_UN)
    end
    r = r.reverse[0...20].inject('') {|p,l| p+l}
  end
  dat = c(HALL, %Q(<div class="log"><table class="logList">\n#{r}</table></div>), users, topic)

  File.open('cache.txt', 'w') do |ofile|
    ofile.flock(File::LOCK_EX)
    ofile.puts(dat)
    ofile.flock(File::LOCK_UN)
  end

  udb.roots.each do |u|
    next if u == user || u =~ /^__/
    pid = udb[u][:pid]
    if pid
      begin
        Process.kill(:USR1, pid)
      rescue
        udb[u].delete(:pid)
      end
    else
      udb[u][:up] = true
    end
  end
end

def mkdat(user = nil)
  udb = get_udb
  udb.transaction do
    mkdat_udb(udb, user)
  end
end
