PLUGIN_RB = '_plugins.rb'

class Plugin
  def type
    :filter
  end
  def ok?(msg)
    true
  end
  def set(udb, user, img)
    @udb = udb
    @user = user
	@img = img
  end
end

class PluginMgr

  def initialize(udb, user, img)
    @udb = udb
    @user = user
	@img = img
  end

  def reconstruct_plugins
    File.open(PLUGIN_RB, 'w') do |ofile|
      ofile.flock(File::LOCK_EX)
      ofile.puts('# this is generated code. DO NOT MODIFY.')

      names = []
      Dir.glob('plugins/*.rb').sort.each do |p|
        p =~ /plugins\/(.*?)\.rb$/
        n = "#{$1.capitalize}Plugin"
        names.push("#{n}.new")
        ofile.puts("class #{n} < Plugin")
        File.open(p, 'r') do |ifile|
          ofile.puts(ifile.read)
        end
        ofile.puts('end')
      end
      ofile.puts(%Q(def plugins
@plugins = [#{names.join(',')}] if !@plugins
@plugins
end
))
      ofile.flock(File::LOCK_UN)
    end
  end

  def load_plugins
    if !File.exist?(PLUGIN_RB) || File.mtime('plugins') > File.mtime(PLUGIN_RB)
      reconstruct_plugins
    end
    File.open(PLUGIN_RB, 'r') do |ifile|
      ifile.flock(File::LOCK_SH)
      require PLUGIN_RB
      ifile.flock(File::LOCK_UN)
    end
    plugins
  end

  def apply_plugin(msg)
    return '' if msg == ''

    load_plugins

    plugins.each do |plugin|
      plugin.set(@udb, @user, @img)
      if plugin.ok?(msg)
        case plugin.type
        when :filter
          msg = plugin.apply(msg)
          return '' if msg == ''
        when :command
          fork do
            plugin.apply(msg)
          end
        when :system
        else
          raise "#{plugin.type}Υץ饰󥿥פǤ"
        end
      end
    end
    msg
  end

  def apply_sys_plugin(type)
    load_plugins
    plugins.each do |plugin|
      plugin.set(@udb, @user, @img)
      if plugin.respond_to?(:apply_sys_plugin)
        plugin.apply_sys_plugin(type)
      end
    end
  end

end
